<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/22/2004 *
 * ===================                          Last change: 09/22/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_home.php                             *
 * -------------------------------------------------------------------- *
 * Short description : Set 'home' page                                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : 'home'-Seite festlegen                           *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2012 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

// Init 'sub' value
$sub = '';
if (isGetRequestElementSet('sub')) {
	$sub = getRequestElement('sub');
} // END - if

switch ($sub) {
	case 'settings': // Settings related to the index page
		if (isFormSent()) {
			// Save settings
			adminSaveSettingsFromPostData();

			// Display continue link
			displayMessage('<a href="{%url=modules.php?module=admin&amp;what=config_home&amp;sub=settings%}">{--ADMIN_CONTINUE_TO_CONFIG--}</a>');
		} else {
			// Prepare data for the template
			$content = array_fill(-1, 60, '');
			$content[getConfig('index_delay')] = ' selected="selected"';

			// Generate selection
			$content['cookie_selection'] = createConfigurationTimeSelections('index_cookie', 'YMWD');

			// Output form
			loadTemplate('admin_config_home', false, $content);
		}
		break;

	case 'target': // Set which what-file will be placed in home-page (only modules.php?module=index)
		if (isGetRequestElementSet('home')) {
			// Set new home
			updateConfiguration('index_home', getRequestElement('home'));
		} // END - if

		// Load all what menu points
		$result = SQL_QUERY("SELECT
	`id`,
	`what`,
	`title`
FROM
	`{?_MYSQL_PREFIX?}_guest_menu`
WHERE
	`action`='main' AND
	`what` != '' AND
	`what` IS NOT NULL AND
	`locked`='N'
ORDER BY
	`sort` ASC", __FILE__, __LINE__);

		// Init variables
		$OUT = '';

		// Process all entries
		while ($content = SQL_FETCHARRAY($result)) {
			// Link for setting 'what' as new 'home'
			$newHomeLink = '<a href="{%url=modules.php?module=admin&amp;what=config_home&amp;sub=target&amp;home=' . $content['what'] . '%}">{--_IS_NEW_HOME--}</a>';

			// Is this current home?
			if ($content['what'] == getIndexHome()) {
				// Is current home
				$newHomeLink      = '<div class="admin_mark">{--_IS_CURRENT_HOME--}</div>';
				$content['title'] = '<div class="admin_mark">' . $content['title'] . '</div>';
			} // END - if

			// Prepare content
			$content['link'] = $newHomeLink;

			// Load row template
			$OUT .= loadTemplate('admin_list_home_row', true, $content);
		} // END - while

		// Free memory
		SQL_FREERESULT($result);

		// Load template
		loadTemplate('admin_list_home', false, $OUT);
		break;

	default: // Output selection table
		loadTemplate('admin_config_home_main');
		break;
} // END - switch

// [EOF]
?>
