<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 01/27/2004 *
 * ===================                          Last change: 07/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_cats.php                               *
 * -------------------------------------------------------------------- *
 * Short description : List selected categories from users              *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Ausgewaehlte Kategorien eines Mitgliedes         *
 *                     auflisten                                        *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2012 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

if (isGetRequestElementSet('userid')) {
	// Check if the user already exists
	if (fetchUserData(getRequestElement('userid'))) {
		// Loads surname, family's name and the email address
		$content = getUserDataArray();

		// Prepare constants
		// @TODO No longer needed? define('__CATEGORIES_BASE'   , '<a href="{%url=modules.php?module=admin&amp;userid=');
		$content['email']  = '<a href="' . generateEmailLink($content['email'], 'user_data') . '">{%pipe,translateGender=' . $content['gender'] . '%} ' . $content['surname'] . ' ' . $content['family'] . '</a>';

		// Ok, list categories of this user
		$result_cats = SQL_QUERY("SELECT `id`,`cat` FROM `{?_MYSQL_PREFIX?}_cats` ORDER BY `sort` ASC", __FILE__, __LINE__);

		if (!SQL_HASZERONUMS($result_cats)) {
			// List categories
			$count = 1; $OUT = '';
			while ($row = SQL_FETCHARRAY($result_cats)) {
				// Merge both arrays
				$content = merge_array($content, $row);

				// Check user's selection
				// @TODO Rewrite this to countSum.....() function
				$result_user = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_user_cats` WHERE `userid`=%s AND `cat_id`=%s LIMIT 1",
					array(bigintval(getRequestElement('userid')), bigintval($content['id'])), __FILE__, __LINE__);

				// Set selection
				$selection = '<font color="#ee0000">{--NO--}</div>';
				if (SQL_NUMROWS($result_user) == 1) {
					$selection = '<font color="#00ee00">{--YES--}</div>';
				} // END - if

				// Add more elements
				$content['count'] = $count;
				$content['sel']   = $selection;

				// Load row template and count up
				$OUT .= loadTemplate('admin_list_user_cats_row', true, $content);
				$count++;
			} // END - while

			// Free memory
			SQL_FREERESULT($result_cats);

			// Remember all rows in the array
			$content['rows'] = $OUT;

			// Load main template
			loadTemplate('admin_list_user_cats', false, $content);
		} else {
			// No categories selected! :-(
			loadTemplate('admin_list_user_cats_404', false, $content);
		}
	} else {
		// User not found
		displayMessage('{%message,ADMIN_MEMBER_404=' . $content['userid'] . '%}');
	}
} else {
	// Output selection form with all confirmed user accounts listed
	addMemberSelectionBox();
}

// [EOF]
?>
