<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 08/27/2004 *
 * ===================                          Last change: 08/27/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-stats_mods.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Module statistics                                *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Modul-Statistiken                                *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2012 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

// Check if module was selected
if ((getRequestElement('mod') == 'index') || (getRequestElement('mod') == 'login')) {
	// Select menu system
	$mod = mapModuleToTable(getRequestElement('mod'));

	// Load module's detail statistic
	$result = SQL_QUERY_ESC("SELECT `action`,`title`,`counter` FROM `{?_MYSQL_PREFIX?}_%s_menu` WHERE `what` != '' AND `what` IS NOT NULL ORDER BY `counter` DESC",
		array($mod), __FILE__, __LINE__);
	$OUT = '';
	while ($content = SQL_FETCHARRAY($result)) {
		// Load row template
		$OUT .= loadTemplate('admin_list_mods_stats2_row', true, $content);
	} // END - while

	// Free memory
	SQL_FREERESULT($result);

	// Load final template
	loadTemplate('admin_list_mods_stats2', false, $OUT);
} else {
	// Load module statics
	$result = SQL_QUERY("SELECT `module`,`title`,`clicks` FROM `{?_MYSQL_PREFIX?}_mod_reg` ORDER BY `clicks` DESC,`module` ASC", __FILE__, __LINE__);
	$OUT = '';
	while ($content = SQL_FETCHARRAY($result)) {
		if (($content['module'] == 'index') || ($content['module'] == 'login')) {
			// Add link to detail statistics
			$content['module'] = '<a href="{%url=modules.php?module=admin&amp;what=stats_mods&amp;mod=' . $content['module'] . '%}">' . $content['module'] . '</a>';
		} // END - if

		// Load row template
		$OUT .= loadTemplate('admin_list_mods_stats_row', true, $content);
	} // END - while

	// Free memory
	SQL_FREERESULT($result);

	// Load final template
	loadTemplate('admin_list_mods_stats', false, $OUT);
}

// [EOF]
?>
