<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/29/2003 *
 * ===================                          Last change: 01/06/2006 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : order.php                                        *
 * -------------------------------------------------------------------- *
 * Short description : Submits your order to the administrators         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sendet die Buchung an die Administratoren        *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2012 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
$url = '';
if (!defined('__SECURITY')) {
	exit();
} elseif ((!isExtensionActive('order')) && (!isAdmin())) {
	displayMessage('{%pipe,generateExtensionInactiveNotInstalledMessage=order%}');
	return;
} elseif (!isMember()) {
	// Sorry, no guest access!
	$url = 'modules.php?module=index';
} elseif (!isGetRequestElementSet('order')) {
	// You cannot call this module directly!
	$url = 'modules.php?module=login&amp;what=order';
}

// When URL is empty nothing bad happend here
if (empty($url)) {
	// Auto-send is inactive
	$content['admin_autosend']  = '{--ADMIN_AUTOSEND_INACTIVE--}';
	$content['member_autosend'] = '{--MEMBER_AUTOSEND_INACTIVE--}';
	$type = 'ADMIN';

	// Is the auto-send mechanism active or inactive?
	if (getConfig('autosend_active') == 'Y') {
		// Auto-send is active
		$content['admin_autosend']  = '{--ADMIN_AUTOSEND_ACTIVE--}';
		$content['member_autosend'] = '{--MEMBER_AUTOSEND_ACTIVE--}';
		$type = 'NEW';
	} // END - if

	// Update sending pool
	SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_pool` SET `data_type`='%s' WHERE `id`=%s AND `sender`=%s AND `data_type`='TEMP' LIMIT 1",
		array(
			$type,
			bigintval(getRequestElement('order')),
			getMemberId()
		), __FILE__, __LINE__);

	// Finally is the entry valid?
	if (!SQL_HASZEROAFFECTED()) {
		// @TODO Unused: 2,4
		// Load mail again...              0         1          2             3            4         5       6            7
		$result = SQL_QUERY_ESC("SELECT `subject`,`text`,`receivers`,`payment_id`,`timestamp`,`url`,`cat_id`,`target_send` FROM `{?_MYSQL_PREFIX?}_pool` WHERE `id`=%s AND `sender`=%s LIMIT 1",
			array(
				bigintval(getRequestElement('order')),
				getMemberId()
			), __FILE__, __LINE__);

		// Merge arrays
		$content = merge_array($content, SQL_FETCHARRAY($result));

		// Free result
		SQL_FREERESULT($result);

		// Fix empty subject line
		if (empty($content['subject'])) {
			$content['subject'] = '{--DEFAULT_SUBJECT_LINE--}';
		} // END - if

		// Calculate used points
		$content['payed_points'] = $content['target_send'] * getPaymentData($content['payment_id']);

		// Subtract them from the user's account and ignore return status
		subtractPoints('order', getMemberId(), $content['payed_points']);

		// Update used points
		$add = '';
		if ((isExtensionInstalledAndNewer('order', '0.1.1')) && (getConfig('order_max_full') == 'ORDER')) {
			$add = ',`mail_orders`=`mail_orders`+1';
		} // END - if

		// Send an email to the user
		$message_mem = loadEmailTemplate('member_order_normal', $content, getMemberId());
		sendEmail(getMemberId(), '{--MEMBER_NEW_QUEUE--}', $message_mem);

		// Notify admins about this
		sendAdminNotification('{--ADMIN_NEW_QUEUE--}', 'admin_order_normal', $content, getMemberId());

		// Create new task (we ignore the task id here)
		createNewTask(
			'{--ADMIN_NEW_QUEUE--}',
			'<pre>' . loadEmailTemplate('admin_order_normal', $content, getMemberId()) . '</pre>',
			'MEMBER_ORDER',
			getMemberId(),
			0,
			false
		);

		// Output back bottom
		loadTemplate('member_order_thanks');
	} else {
		// Matching line not found or already 'placed' in send queue
		redirectToUrl('modules.php?module=login');
	}
} else {
	// Redirect...
	redirectToUrl($url);
}

// [EOF]
?>
